DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Charts - Drill-Down

This demo shows a drill-down chart that visualizes data on two hierarchical views. The main view displays the population breakdown by continent. When you click the bar, a detailed view reveals the most populated countries on the selected continent.

Backend API
$(() => { let isFirstLevel = true; const chartContainer = $('#chart'); const chart = chartContainer.dxChart({ dataSource: filterData(''), title: 'The Most Populated Countries by Continents', series: { type: 'bar', }, legend: { visible: false, }, valueAxis: { showZero: false, }, onPointClick(e) { if (isFirstLevel) { isFirstLevel = false; removePointerCursor(chartContainer); chart.option({ dataSource: filterData(e.target.originalArgument), }); $('#backButton') .dxButton('instance') .option('visible', true); } }, customizePoint() { const pointSettings = { color: colors[Number(isFirstLevel)], }; if (!isFirstLevel) { pointSettings.hoverStyle = { hatching: 'none', }; } return pointSettings; }, }).dxChart('instance'); $('#backButton').dxButton({ text: 'Back', icon: 'chevronleft', visible: false, onClick() { if (!isFirstLevel) { isFirstLevel = true; addPointerCursor(chartContainer); chart.option('dataSource', filterData('')); this.option('visible', false); } }, }); addPointerCursor(chartContainer); }); function filterData(name) { return data.filter((item) => item.parentID === name); } function addPointerCursor(container) { container.addClass('pointer-on-bars'); } function removePointerCursor(container) { container.removeClass('pointer-on-bars'); }
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="chart"></div> <div class="button-container"> <div id="backButton"></div> </div> </div> </body> </html>
#chart { height: 440px; width: 100%; } #chart.pointer-on-bars .dxc-series rect { cursor: pointer; } .button-container { text-align: center; height: 40px; position: absolute; top: 7px; left: 0; }
const colors = ['#6babac', '#e55253']; const data = [ { arg: 'Asia', val: 3007613498, parentID: '' }, { arg: 'North America', val: 493603615, parentID: '' }, { arg: 'Europe', val: 438575293, parentID: '' }, { arg: 'Africa', val: 381331438, parentID: '' }, { arg: 'South America', val: 331126555, parentID: '' }, { arg: 'Nigeria', val: 181562056, parentID: 'Africa' }, { arg: 'Egypt', val: 88487396, parentID: 'Africa' }, { arg: 'Congo', val: 77433744, parentID: 'Africa' }, { arg: 'Morocco', val: 33848242, parentID: 'Africa' }, { arg: 'China', val: 1380083000, parentID: 'Asia' }, { arg: 'India', val: 1306687000, parentID: 'Asia' }, { arg: 'Pakistan', val: 193885498, parentID: 'Asia' }, { arg: 'Japan', val: 126958000, parentID: 'Asia' }, { arg: 'Russia', val: 146804372, parentID: 'Europe' }, { arg: 'Germany', val: 82175684, parentID: 'Europe' }, { arg: 'Turkey', val: 79463663, parentID: 'Europe' }, { arg: 'France', val: 66736000, parentID: 'Europe' }, { arg: 'United Kingdom', val: 63395574, parentID: 'Europe' }, { arg: 'United States', val: 325310275, parentID: 'North America' }, { arg: 'Mexico', val: 121005815, parentID: 'North America' }, { arg: 'Canada', val: 36048521, parentID: 'North America' }, { arg: 'Cuba', val: 11239004, parentID: 'North America' }, { arg: 'Brazil', val: 205737996, parentID: 'South America' }, { arg: 'Colombia', val: 48400388, parentID: 'South America' }, { arg: 'Venezuela', val: 30761000, parentID: 'South America' }, { arg: 'Peru', val: 28220764, parentID: 'South America' }, { arg: 'Chile', val: 18006407, parentID: 'South America' }, ];

Bind to Data

This demo binds the drill-down chart to an array of objects. To visualize hierarchical data in the drill-down chart, filter the data source by the parentID for different drill-down views in the filterData function.

Implement View Navigation

To navigate from the main view to a detailed view, filter the data source by a different parentID in the onPointClick event handler. To navigate back, click the Back button. This action resets the data source filter. Use the isFirstLevel flag to distinguish views.

Customize the Appearance

Use the customizePoint function to change the individual point properties. This function returns an object with properties that should be changed for a certain point. In this demo, this function changes the color and hoverStyle properties.

<template>
<div>
<DxChart
id="chart"
:customize-point="customizePoint"
:class="isFirstLevel ? 'pointer-on-bars' : ''"
:data-source="dataSource"
title="The Most Populated Countries by Continents"
@point-click="onPointClick"
>
<DxSeries type="bar"/>
<DxValueAxis :show-zero="false"/>
<DxLegend :visible="false"/>
</DxChart>
<DxButton
:visible="!isFirstLevel"
class="button-container"
text="Back"
icon="chevronleft"
@click="onButtonClick"
/>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxChart,
DxSeries,
DxValueAxis,
DxLegend,
type DxChartTypes,
} from 'devextreme-vue/chart';
import { DxButton } from 'devextreme-vue/button';
import { type SeriesPoint } from 'devextreme-vue/common/charts';
import service from './data.ts';
const isFirstLevel = ref(true);
const dataSource = ref(service.filterData(''));
const colors = ['#6babac', '#e55253'];
function customizePoint(): SeriesPoint {
return {
color: colors[Number(isFirstLevel.value)],
hoverStyle: {
...!isFirstLevel.value ? { hatching: 'none' } : {},
},
} as SeriesPoint;
}
function onPointClick({ target }: DxChartTypes.PointClickEvent): void {
if (isFirstLevel.value) {
isFirstLevel.value = false;
dataSource.value = service.filterData(target.originalArgument as string);
}
}
function onButtonClick(): void {
if (!isFirstLevel.value) {
isFirstLevel.value = true;
dataSource.value = service.filterData('');
}
}
</script>
<style>
#chart {
height: 440px;
width: 100%;
}
#chart.pointer-on-bars .dxc-series rect {
cursor: pointer;
}
.button-container {
text-align: center;
height: 40px;
position: absolute;
top: 7px;
left: 0;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
interface DataItem {
arg: string;
val: number;
parentID: string;
}
const data: DataItem[] = [
{ arg: 'Asia', val: 3007613498, parentID: '' },
{ arg: 'North America', val: 493603615, parentID: '' },
{ arg: 'Europe', val: 438575293, parentID: '' },
{ arg: 'Africa', val: 381331438, parentID: '' },
{ arg: 'South America', val: 331126555, parentID: '' },
{ arg: 'Nigeria', val: 181562056, parentID: 'Africa' },
{ arg: 'Egypt', val: 88487396, parentID: 'Africa' },
{ arg: 'Congo', val: 77433744, parentID: 'Africa' },
{ arg: 'Morocco', val: 33848242, parentID: 'Africa' },
{ arg: 'China', val: 1380083000, parentID: 'Asia' },
{ arg: 'India', val: 1306687000, parentID: 'Asia' },
{ arg: 'Pakistan', val: 193885498, parentID: 'Asia' },
{ arg: 'Japan', val: 126958000, parentID: 'Asia' },
{ arg: 'Russia', val: 146804372, parentID: 'Europe' },
{ arg: 'Germany', val: 82175684, parentID: 'Europe' },
{ arg: 'Turkey', val: 79463663, parentID: 'Europe' },
{ arg: 'France', val: 66736000, parentID: 'Europe' },
{ arg: 'United Kingdom', val: 63395574, parentID: 'Europe' },
{ arg: 'United States', val: 325310275, parentID: 'North America' },
{ arg: 'Mexico', val: 121005815, parentID: 'North America' },
{ arg: 'Canada', val: 36048521, parentID: 'North America' },
{ arg: 'Cuba', val: 11239004, parentID: 'North America' },
{ arg: 'Brazil', val: 205737996, parentID: 'South America' },
{ arg: 'Colombia', val: 48400388, parentID: 'South America' },
{ arg: 'Venezuela', val: 30761000, parentID: 'South America' },
{ arg: 'Peru', val: 28220764, parentID: 'South America' },
{ arg: 'Chile', val: 18006407, parentID: 'South America' },
];
export default {
filterData(name: string): DataItem[] {
return data.filter((item) => item.parentID === name);
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<dx-chart
id="chart"
[class]="isFirstLevel ? 'pointer-on-bars' : ''"
[dataSource]="dataSource"
(onPointClick)="onPointClick($event)"
title="The Most Populated Countries by Continents"
[customizePoint]="customizePoint"
>
<dxi-chart-series type="bar"></dxi-chart-series>
<dxo-chart-legend [visible]="false"></dxo-chart-legend>
<dxi-chart-value-axis [showZero]="false"></dxi-chart-value-axis>
</dx-chart>
<dx-button
class="button-container"
text="Back"
icon="chevronleft"
[visible]="!isFirstLevel"
(onClick)="onButtonClick()"
>
</dx-button>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxChartModule, DxButtonModule } from 'devextreme-angular';
import { Service, DataItem } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxChartModule,
DxButtonModule,
],
})
export class AppComponent {
dataSource: DataItem[];
colors: string[];
service: Service;
isFirstLevel: boolean;
constructor(service: Service) {
this.dataSource = service.filterData('');
this.colors = service.getColors();
this.service = service;
this.isFirstLevel = true;
}
onButtonClick() {
if (!this.isFirstLevel) {
this.isFirstLevel = true;
this.dataSource = this.service.filterData('');
}
}
onPointClick(e) {
if (this.isFirstLevel) {
this.isFirstLevel = false;
this.dataSource = this.service.filterData(e.target.originalArgument);
}
}
customizePoint = () => ({
color: this.colors[Number(this.isFirstLevel)],
...this.isFirstLevel ? {} : {
hoverStyle: {
hatching: 'none',
},
},
});
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
#chart {
height: 440px;
width: 100%;
}
::ng-deep #chart.pointer-on-bars .dxc-series rect {
cursor: pointer;
}
.button-container {
text-align: center;
height: 40px;
position: absolute;
top: 7px;
left: 0;
}
import { Injectable } from '@angular/core';
export class DataItem {
arg: string;
val: number;
parentID: string;
}
const data: DataItem[] = [
{ arg: 'Asia', val: 3007613498, parentID: '' },
{ arg: 'North America', val: 493603615, parentID: '' },
{ arg: 'Europe', val: 438575293, parentID: '' },
{ arg: 'Africa', val: 381331438, parentID: '' },
{ arg: 'South America', val: 331126555, parentID: '' },
{ arg: 'Nigeria', val: 181562056, parentID: 'Africa' },
{ arg: 'Egypt', val: 88487396, parentID: 'Africa' },
{ arg: 'Congo', val: 77433744, parentID: 'Africa' },
{ arg: 'Morocco', val: 33848242, parentID: 'Africa' },
{ arg: 'China', val: 1380083000, parentID: 'Asia' },
{ arg: 'India', val: 1306687000, parentID: 'Asia' },
{ arg: 'Pakistan', val: 193885498, parentID: 'Asia' },
{ arg: 'Japan', val: 126958000, parentID: 'Asia' },
{ arg: 'Russia', val: 146804372, parentID: 'Europe' },
{ arg: 'Germany', val: 82175684, parentID: 'Europe' },
{ arg: 'Turkey', val: 79463663, parentID: 'Europe' },
{ arg: 'France', val: 66736000, parentID: 'Europe' },
{ arg: 'United Kingdom', val: 63395574, parentID: 'Europe' },
{ arg: 'United States', val: 325310275, parentID: 'North America' },
{ arg: 'Mexico', val: 121005815, parentID: 'North America' },
{ arg: 'Canada', val: 36048521, parentID: 'North America' },
{ arg: 'Cuba', val: 11239004, parentID: 'North America' },
{ arg: 'Brazil', val: 205737996, parentID: 'South America' },
{ arg: 'Colombia', val: 48400388, parentID: 'South America' },
{ arg: 'Venezuela', val: 30761000, parentID: 'South America' },
{ arg: 'Peru', val: 28220764, parentID: 'South America' },
{ arg: 'Chile', val: 18006407, parentID: 'South America' },
];
const colors: string[] = ['#6babac', '#e55253'];
@Injectable()
export class Service {
filterData(name): DataItem[] {
return data.filter((item) => item.parentID === name);
}
getColors(): string[] {
return colors;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Charts - Drill-Down

This demo shows a drill-down chart that visualizes data on two hierarchical views. The main view displays the population breakdown by continent. When you click the bar, a detailed view reveals the most populated countries on the selected continent.

Backend API
import React, { useCallback, useState } from 'react'; import { Chart, Series, Legend, ValueAxis, type ChartTypes, } from 'devextreme-react/chart'; import { Button } from 'devextreme-react/button'; import service from './data.ts'; const colors = ['#6babac', '#e55253']; function App() { const [isFirstLevel, setIsFirstLevel] = useState(true); const [data, setData] = useState(service.filterData('')); const customizePoint = useCallback((): { color: string, hoverStyle?: { color?: string, hatching?: string } } => ({ color: colors[Number(isFirstLevel)], hoverStyle: !isFirstLevel ? { hatching: 'none', } : {}, }), [isFirstLevel]); const onPointClick = useCallback((e: ChartTypes.PointClickEvent) => { if (isFirstLevel) { setIsFirstLevel(false); setData(service.filterData(e.target.originalArgument.toString())); } }, [isFirstLevel, setData, setIsFirstLevel]); const onButtonClick = useCallback(() => { if (!isFirstLevel) { setIsFirstLevel(true); setData(service.filterData('')); } }, [isFirstLevel, setData, setIsFirstLevel]); return ( <div> <Chart id="chart" title="The Most Populated Countries by Continents" customizePoint={customizePoint} onPointClick={onPointClick} className={isFirstLevel ? 'pointer-on-bars' : ''} dataSource={data} > <Series type="bar" /> <ValueAxis showZero={false} /> <Legend visible={false} /> </Chart> <Button className="button-container" text="Back" icon="chevronleft" visible={!isFirstLevel} onClick={onButtonClick} /> </div> ); } export default App;
import React, { useCallback, useState } from 'react'; import { Chart, Series, Legend, ValueAxis, } from 'devextreme-react/chart'; import { Button } from 'devextreme-react/button'; import service from './data.js'; const colors = ['#6babac', '#e55253']; function App() { const [isFirstLevel, setIsFirstLevel] = useState(true); const [data, setData] = useState(service.filterData('')); const customizePoint = useCallback( () => ({ color: colors[Number(isFirstLevel)], hoverStyle: !isFirstLevel ? { hatching: 'none', } : {}, }), [isFirstLevel], ); const onPointClick = useCallback( (e) => { if (isFirstLevel) { setIsFirstLevel(false); setData(service.filterData(e.target.originalArgument.toString())); } }, [isFirstLevel, setData, setIsFirstLevel], ); const onButtonClick = useCallback(() => { if (!isFirstLevel) { setIsFirstLevel(true); setData(service.filterData('')); } }, [isFirstLevel, setData, setIsFirstLevel]); return ( <div> <Chart id="chart" title="The Most Populated Countries by Continents" customizePoint={customizePoint} onPointClick={onPointClick} className={isFirstLevel ? 'pointer-on-bars' : ''} dataSource={data} > <Series type="bar" /> <ValueAxis showZero={false} /> <Legend visible={false} /> </Chart> <Button className="button-container" text="Back" icon="chevronleft" visible={!isFirstLevel} onClick={onButtonClick} /> </div> ); } export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
const data = [ { arg: 'Asia', val: 3007613498, parentID: '' }, { arg: 'North America', val: 493603615, parentID: '' }, { arg: 'Europe', val: 438575293, parentID: '' }, { arg: 'Africa', val: 381331438, parentID: '' }, { arg: 'South America', val: 331126555, parentID: '' }, { arg: 'Nigeria', val: 181562056, parentID: 'Africa' }, { arg: 'Egypt', val: 88487396, parentID: 'Africa' }, { arg: 'Congo', val: 77433744, parentID: 'Africa' }, { arg: 'Morocco', val: 33848242, parentID: 'Africa' }, { arg: 'China', val: 1380083000, parentID: 'Asia' }, { arg: 'India', val: 1306687000, parentID: 'Asia' }, { arg: 'Pakistan', val: 193885498, parentID: 'Asia' }, { arg: 'Japan', val: 126958000, parentID: 'Asia' }, { arg: 'Russia', val: 146804372, parentID: 'Europe' }, { arg: 'Germany', val: 82175684, parentID: 'Europe' }, { arg: 'Turkey', val: 79463663, parentID: 'Europe' }, { arg: 'France', val: 66736000, parentID: 'Europe' }, { arg: 'United Kingdom', val: 63395574, parentID: 'Europe' }, { arg: 'United States', val: 325310275, parentID: 'North America' }, { arg: 'Mexico', val: 121005815, parentID: 'North America' }, { arg: 'Canada', val: 36048521, parentID: 'North America' }, { arg: 'Cuba', val: 11239004, parentID: 'North America' }, { arg: 'Brazil', val: 205737996, parentID: 'South America' }, { arg: 'Colombia', val: 48400388, parentID: 'South America' }, { arg: 'Venezuela', val: 30761000, parentID: 'South America' }, { arg: 'Peru', val: 28220764, parentID: 'South America' }, { arg: 'Chile', val: 18006407, parentID: 'South America' }, ]; export default { filterData(name: string) { return data.filter((item) => item.parentID === name); }, };
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', }, defaultExtension: 'js', map: { 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@25.1.5/cjs', 'devextreme-react': 'npm:devextreme-react@25.1.5/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.21/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
const data = [ { arg: 'Asia', val: 3007613498, parentID: '' }, { arg: 'North America', val: 493603615, parentID: '' }, { arg: 'Europe', val: 438575293, parentID: '' }, { arg: 'Africa', val: 381331438, parentID: '' }, { arg: 'South America', val: 331126555, parentID: '' }, { arg: 'Nigeria', val: 181562056, parentID: 'Africa' }, { arg: 'Egypt', val: 88487396, parentID: 'Africa' }, { arg: 'Congo', val: 77433744, parentID: 'Africa' }, { arg: 'Morocco', val: 33848242, parentID: 'Africa' }, { arg: 'China', val: 1380083000, parentID: 'Asia' }, { arg: 'India', val: 1306687000, parentID: 'Asia' }, { arg: 'Pakistan', val: 193885498, parentID: 'Asia' }, { arg: 'Japan', val: 126958000, parentID: 'Asia' }, { arg: 'Russia', val: 146804372, parentID: 'Europe' }, { arg: 'Germany', val: 82175684, parentID: 'Europe' }, { arg: 'Turkey', val: 79463663, parentID: 'Europe' }, { arg: 'France', val: 66736000, parentID: 'Europe' }, { arg: 'United Kingdom', val: 63395574, parentID: 'Europe' }, { arg: 'United States', val: 325310275, parentID: 'North America' }, { arg: 'Mexico', val: 121005815, parentID: 'North America' }, { arg: 'Canada', val: 36048521, parentID: 'North America' }, { arg: 'Cuba', val: 11239004, parentID: 'North America' }, { arg: 'Brazil', val: 205737996, parentID: 'South America' }, { arg: 'Colombia', val: 48400388, parentID: 'South America' }, { arg: 'Venezuela', val: 30761000, parentID: 'South America' }, { arg: 'Peru', val: 28220764, parentID: 'South America' }, { arg: 'Chile', val: 18006407, parentID: 'South America' }, ]; export default { filterData(name) { return data.filter((item) => item.parentID === name); }, };
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.5/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#chart { height: 440px; width: 100%; } #chart.pointer-on-bars .dxc-series rect { cursor: pointer; } .button-container { text-align: center; height: 40px; position: absolute; top: 7px; left: 0; }

Bind to Data

This demo binds the drill-down chart to an array of objects. To visualize hierarchical data in the drill-down chart, filter the data source by the parentID for different drill-down views in the filterData function.

Implement View Navigation

To navigate from the main view to a detailed view, filter the data source by a different parentID in the onPointClick event handler. To navigate back, click the Back button. This action resets the data source filter. Use the isFirstLevel flag to distinguish views.

Customize the Appearance

Use the customizePoint function to change the individual point properties. This function returns an object with properties that should be changed for a certain point. In this demo, this function changes the color and hoverStyle properties.